# This script is designed to be run by the CI under a venv set by requirements.txt in the repo root.
# Take a look at the Jenkinsfile for the general idea.
# It should be run as /doc/build_docs_ci.sh from the repo root as the cwd.

if [ -z "$1" ]
  then
    echo "Please pass the xmosdoc version. Eg. $/doc/build_docs_ci.sh v4.0"
    exit -1
fi

# Build the autogenerated section. Commented out since run on a different agent with xcore.ai HW attached.
#cd doc/python
#python doc_asrc.py
#cd ../..

# Create the docs from source
docker pull ghcr.io/xmos/xmosdoc:$1
docker run -u "$(id -u):$(id -g)" --rm -v `pwd`:/build  ghcr.io/xmos/xmosdoc:$1 -v

# Leave a nice zip file for picking up as an artefact
cd doc/_build
zip -r doc_build.zip .
